<?php

define('IN_COPPERMINE', true);
require('include/init.inc.php');
pageheader('Trimmer');

if ($_POST){
	$report = array();

	foreach ($_POST['opt'] as $option => $value){
		
		switch ($option){
			case 'clean_missing_files' :
				$del = false;
				$result = db_query("SELECT pid, filepath, filename FROM {$CONFIG['TABLE_PICTURES']}");
				while ($row = mysql_fetch_assoc($result)){
					if (!file_exists($CONFIG['fullpath'] . $row['filepath'] . $row['filename'])){
						$del = db_query("DELETE FROM {$CONFIG['TABLE_PICTURES']} WHERE pid = {$row['pid']} LIMIT 1");
						$report[] = "Missing file '{$row['filepath']}{$row['filename']}' was removed from the database."; 
					}
				}
				if (!$del) $report[] = 'No missing files were discovered';
				break;
				
			case 'clean_albs' : 
				$result = db_query("SELECT DISTINCT(aid) FROM {$CONFIG['TABLE_PICTURES']}");
				$valid_aids = array();
				while ($row = mysql_fetch_row($result)){
					$valid_aids[] = $row[0];
				}
				mysql_free_result($result);
				$aidstr = '(' . implode(',',$valid_aids) . ')';
				$result = db_query("DELETE FROM {$CONFIG['TABLE_ALBUMS']} WHERE aid NOT IN $aidstr");
				$report[] = mysql_affected_rows() . ' empty albums were deleted';
				break;
				
		case 'clean_cats' : 
				$result = db_query("SELECT DISTINCT(category) FROM {$CONFIG['TABLE_ALBUMS']}");
				$valid_cids = array(1);
				while ($row = mysql_fetch_row($result)){
					$valid_cids[] = $row[0];
				}
				mysql_free_result($result);
				$cidstr = '(' . implode(',',$valid_cids) . ')';
				$result = db_query("DELETE FROM {$CONFIG['TABLE_CATEGORIES']} WHERE cid NOT IN $cidstr");
				$report[] = mysql_affected_rows() . ' empty categories were deleted';
				break;
	
				
			default :
				$report[] = "'$option' is not a supported option";
				break;
		}
	
	}
	showreport($report);
	
} else {

	$options = array(
		'clean_missing_files' => 'Remove missing pictures',
		'clean_albs' => 'Remove empty albums',
		'clean_cats' => 'Remove empty categories',
	);

	echo '<form method="post" action="trimmer.php">';

	starttable('60%', 'Options');
	echo '	<tr>
			<td class="tableb">
	';
	
	foreach ($options as $key => $caption){
		echo <<< EOT
				<input type="checkbox" name="opt[$key]" class="checkbox" />
				<label>$caption</label>
				<br />
EOT;
	}
	
	echo <<< EOT
					</td>
			</tr>
			<tr>
					<td align="center" class="tablef">
						<input type="submit" value="Start" class="button">
					</td>
			</tr>
EOT;

	endtable();
	echo '</form>';
}

pagefooter();

function showreport($report)
{
	starttable('60%', 'Report');
	echo '	<tr><td class="tableb">', implode('<br />', $report), '</td></tr>';                                    
	endtable();
}